/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>

#include "tubeclock.h"

void loadtheimages();
void showthetime(GtkWidget *, int, int, int, int);
void update_time(GtkWidget *);

int half_size=0;
int prevmin=-1, digittoshow= 0;
  GdkPixbuf *d[10], *background_pixbuf, *background_pixbuf_blank;
  GdkPixbuf *background_pixbuf_blank_scaled;
  GdkPixbuf *reflection_pixbuf;
  GdkColormap *colormap;
  GdkDrawable *background_drawable ;
GdkPixbuf *background_pixbuf_scaled;
GdkPixmap *background_pixmap;
GdkBitmap *background_mask_scaled, *background_mask;
GdkGC *background_gc;
  GtkWidget *TubeClock,*fixed1;
GtkWidget *menu1;
GtkWidget *aboutwindow;
char mask_data[HEIGHT*WIDTH];
static unsigned char bmap_bits[] = { 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 
  0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff}; 
static unsigned char bmap_bits_small[] = { 
  0xff};
int twentyfourhourmode=1;

static char *text_for_about = PACKAGE " " VERSION"

Using images in "IMAGE_DIR"
";


int
main (int argc, char *argv[])
{
  
 
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  TubeClock = create_TubeClock ();
  menu1 = create_menu1();
  aboutwindow = create_aboutwindow();

  gtk_widget_show (TubeClock);

  /* turn off window manager border */
  gdk_window_set_decorations(GDK_WINDOW(TubeClock->window), 0);

  colormap=gdk_colormap_get_system();
  loadtheimages();

  /* create the empty pixbuf for the half-size image */
  background_pixbuf_scaled = gdk_pixbuf_new(GDK_COLORSPACE_RGB, TRUE,
					    8, WIDTH, HEIGHT);
  
  /* create the drawable... */
	background_drawable=gdk_pixmap_new(TubeClock->window, WIDTH,HEIGHT, -1);
	/* now fill it in with something recognizable. */

	/* get the initial graphcs context */
  background_gc = gdk_gc_new (background_drawable);
  
  /*  gdk_gc_set_clip_mask(background_gc, background_mask); */
 gdk_draw_rectangle(background_drawable, background_gc,
		     TRUE, 0, 0, WIDTH,HEIGHT);


  update_time(TubeClock);
  g_timeout_add(1000, (GSourceFunc)&update_time, TubeClock);

gtk_main (); 

  return 0;
}

void update_time(GtkWidget *window) {
   int hour, min;
  time_t t;
  struct tm *thetime;
	
    time(&t);
    thetime = localtime(&t);
    
    hour=thetime->tm_hour;
    min=thetime->tm_min;

    if ( (! twentyfourhourmode) && (hour > 12 )) {
      hour -= 12;
    }
       
    /*    printf("update_time called; min=%d, prevmin=%d\n", min, prevmin); */

	if ( min != prevmin ) { 

	  showthetime(window, hour/10, hour-(hour/10)*10,
		      min/10, min-(min/10)*10);

      prevmin = min;
      /*
      printf("returned from showthetime\n");
      */
	}
	 
}

/* showthetime: displays the indicated digits in the clock */

void showthetime(GtkWidget *window, int digit1, int digit2, int digit3, int digit4) {
  GtkWidget *background = lookup_widget(GTK_WIDGET(window), "background");


      /* create a pixmap and mask bitmap out of the blank background */

      gdk_pixbuf_render_pixmap_and_mask ( background_pixbuf_blank,
					  &background_drawable,
					  &background_mask,
					  128 );
      
      /* draw the digits */

      gdk_draw_pixbuf(background_drawable, NULL, d[digit4],
		      0, 0, MIN2X,MIN2Y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      gdk_draw_pixbuf(background_drawable, NULL, d[digit3],
		      0, 0, MIN1X,MIN1Y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      gdk_draw_pixbuf(background_drawable, NULL, d[digit2],
		      0, 0, HOUR2X,HOUR2Y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      gdk_draw_pixbuf(background_drawable, NULL, d[digit1],
		      0, 0, HOUR1X,HOUR1Y,
		      -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);
      /* may be able to draw the reflection once into the blank background,
       but for now it's here */
      gdk_draw_pixbuf(background_drawable, NULL, reflection_pixbuf,
		      0, 0, 0, 0, -1, -1, GDK_RGB_DITHER_NORMAL, 0, 0);


      /* make the half-size pixbuf if needed */

      if ( half_size ) {

	/* put the completed drawable into pixbuf so we can scale it */

	gdk_pixbuf_get_from_drawable(background_pixbuf, background_drawable,
                                   colormap, 0, 0, 0, 0, WIDTH,HEIGHT);

	/* this one doesn't work quite right (image is offset)
	background_pixbuf_scaled=gdk_pixbuf_scale_simple(
		     	      		 background_pixbuf,
					 WIDTH/2, HEIGHT/2, GDK_INTERP_NEAREST);
	*/
	
	gdk_pixbuf_scale( background_pixbuf, background_pixbuf_scaled,
			  0, 0, WIDTH/2, HEIGHT/2, 0.0, 0.0, 
			  .5, .5, GDK_INTERP_BILINEAR);
	

	/* put the half-size stuff back into the pixmap (drawable) */
	/* We will actually not use the pixmap, just the mask. 
	   Maybe we could just render_alpha to create the mask, but
	   this seems to work best. Also it seems redundant if we've
	   already done it once! */

	gdk_pixbuf_render_pixmap_and_mask ( background_pixbuf_blank_scaled,
					  &background_drawable,
					  &background_mask_scaled,
					  128 );


	gtk_image_set_from_pixbuf(GTK_IMAGE(background), 
				  background_pixbuf_scaled);

	gtk_widget_shape_combine_mask(TubeClock, background_mask_scaled, 0, 0);


      } else {

      /* now put the pixmap back to the image */

      gtk_image_set_from_pixmap(GTK_IMAGE(background), background_drawable,
				background_mask);
      gtk_widget_shape_combine_mask(TubeClock, background_mask, 0, 0);

      }
	 
}

void loadtheimages() {

  int i;

 char filename[255];
  

  for ( i=0; i<10; i++ ) {
    sprintf(filename, IMAGE_DIR"1-%d.png", i);
    d[i]= gdk_pixbuf_new_from_file(filename, NULL);
  }

 
  /* load the background into two pixbufs. One will be the working
     image, the other will be the clean background. */

  background_pixbuf=gdk_pixbuf_new_from_file(IMAGE_DIR"Background.png", NULL);
  background_pixbuf_blank=gdk_pixbuf_new_from_file(IMAGE_DIR"Background.png", NULL);
  background_pixbuf_blank_scaled=gdk_pixbuf_new_from_file(IMAGE_DIR"Background-scaled.png", NULL);
  reflection_pixbuf=gdk_pixbuf_new_from_file(IMAGE_DIR"Reflection.png", NULL);
  
  /* create the mask (blank) */

  background_mask=gdk_bitmap_create_from_data(NULL, bmap_bits, WIDTH, HEIGHT);
  background_mask_scaled=gdk_bitmap_create_from_data(NULL, bmap_bits_small, WIDTH/2, HEIGHT/2);

}


void display_popup() {

  gtk_menu_popup(GTK_MENU(menu1), NULL, NULL, NULL, NULL,0, 
		 gtk_get_current_event_time());
} 

void show_about_window() {
  GtkWidget *abouttext;
  
  abouttext=lookup_widget(GTK_WIDGET(aboutwindow), "label1");

  gtk_label_set_text(GTK_LABEL(abouttext), text_for_about);

  gtk_widget_show(aboutwindow);
}
